#pragma once
#include "Shader.h"
#include "../RHWE/Texture.h"
#include "PointLight.h"
#include "glm.hpp"
#include <vector>
#include <memory>
#include "../RHWE/UserInput.h"

class FurShader : public Shader {
public:
	FurShader(int fur_density, int fur_layers, float fur_length, float fur_thickness, glm::vec3 gravity, glm::vec3 amb_col, glm::vec3 diff_col);
	~FurShader();
	virtual void bindTexture(int unit);
	virtual void setLighting(std::vector<std::shared_ptr<PointLight>> *allLights, int sm_light_id);
	virtual int drawLayers();
	virtual void setLayerUniforms(float layer);
protected:
	std::vector<Texture*> textures;
	Texture* texture;
private:
	void createFurTexture();
	float			fur_length = 1.3f;
	int				fur_layers = 60;
	int				fur_density = 2000;
	float			fur_thickness = 1.0f;	
	glm::vec3		fur_gravity;
};