#version 400 core

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 worldNormal;
out vec4 worldPos4D;
out vec3 viewVector;
out vec2 tex_coords;

uniform mat4 model; 
uniform mat4 view_proj; 
uniform vec3 camera_coords; 


struct Fur {
	float layer;
	float length;
	float thickness;
	vec3 gravity;
};
uniform Fur fur;

void main(){

	vec3 fur_position = position + normalize(normal) * fur.length;
		
	vec3 gravity = mat3(transpose(inverse(model))) * fur.gravity;
	fur_position = fur_position + (gravity * pow(fur.layer, 3));

	gl_Position = view_proj * model * vec4(fur_position, 1);
	worldPos4D = model * vec4(fur_position, 1);

	worldNormal = normalize(mat3(transpose(inverse(model)))*normalize(normal));
	viewVector =  camera_coords - worldPos4D.xyz;
	tex_coords = uv * fur.thickness;
}