#pragma once
#include "Shader.h"
#include "../RHWE/Texture.h"
#include "PointLight.h"
#include <vector>
#include <memory>
#include "../RHWE/UserInput.h"

class TextureShader : public Shader {
public:
	TextureShader(const std::string& path, glm::vec3 amb_col, glm::vec3 spec_col, float shin);
	~TextureShader();
	virtual void bindTexture(int unit);
	void bindTexture(Texture* textureToBind, int unit, char* uniformName, bool clampToBorder);
	virtual void setLighting(std::vector<std::shared_ptr<PointLight>> *allLights, int sm_light_id);
protected:
	Texture* texture;
	Texture* projected_texture0;
	Texture* projected_texture1;
	Texture* projected_texture2;
	Texture* projected_texture3;
	Texture* projected_texture4;
};